/* File:  wctpXmlClientMessageReply.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_CLIENT_MESSAGE_REPLY_HPP
#define WCTP_XML_CLIENT_MESSAGE_REPLY_HPP

#include "wctpXmlOperation.hpp"
#include "wctpXmlClientResponseHeader.hpp"
#include "wctpXmlPayload.hpp"

class wctpXmlClientMessageReply : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlClientMessageReply(); 
    wctpXmlClientMessageReply(const wctpXmlClientMessageReply &); 
    ~wctpXmlClientMessageReply(); 
    wctpXmlClientMessageReply& operator=(const wctpXmlClientMessageReply &);
    
    ////////////////////////////
    // Assemble XML protocol text
    virtual XString 
    AssembleOperation(XmlContext& ctx);

    ////////////////////////////
    // Parse XML protocol text
    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    ////////////////////////////
    // ClientResponseHeader Child Element (always holds)
    wctpXmlClientResponseHeader* 
    GetClientResponseHeader(void);

    ////////////////////////////
    // Payload Child Element (always holds)
    wctpXmlPayload* 
    GetPayload(void);

private:
    virtual void Init(void);
    virtual void Copy(const wctpXmlClientMessageReply &);
    virtual void Free(void);

    wctpXmlClientResponseHeader *m_pClientResponseHeader;
    wctpXmlPayload              *m_pPayload;
    
};
#endif
