/* File:  wctpXmlClientQuery.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_CLIENT_QUERY_HPP
#define WCTP_XML_CLIENT_QUERY_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlClientQuery : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlClientQuery(); 
    wctpXmlClientQuery(const wctpXmlClientQuery &); 
    ~wctpXmlClientQuery(); 
    wctpXmlClientQuery& operator=(const wctpXmlClientQuery &);

    ////////////////////////////
    // reset object to default state 
    virtual void 
    Clear(void);

    ////////////////////////////
    // recipientID attribute
    const char * 
    GetRecipientID(void) const;
    void  
    SetRecipientID(const char *);

    ////////////////////////////
    // senderID attribute
    const char * 
    GetSenderID(void) const;
    void  
    SetSenderID(const char *);

    ////////////////////////////
    // trackingNumber attribute
    const char * 
    GetTrackingNumber(void) const;
    void  
    SetTrackingNumber(const char *);

private:

    virtual void Init(void);
    virtual void Copy(const wctpXmlClientQuery &);
    virtual void Free(void);

    virtual XString 
    AssembleOperation(XmlContext& ctx);

    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    XString m_recipientID;
    XString m_senderID;
    XString m_trackingNumber;
    
};
#endif
