/* File:  wctpXmlLookupData.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_LOOKUP_DATA_HPP
#define WCTP_XML_LOOKUP_DATA_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlLookupData : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlLookupData(); 
    wctpXmlLookupData(const wctpXmlLookupData &); 
    ~wctpXmlLookupData(); 
    wctpXmlLookupData& operator=(const wctpXmlLookupData &);

    ////////////////////////////
    // Assemble XML protocol text
    virtual XString 
    AssembleOperation(XmlContext& ctx);

    ////////////////////////////
    // Parse XML protocol text
    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    ////////////////////////////
    // canRespond attribute
    wctp_bool_t 
    GetCanRespond(void) const;
    void  
    SetCanRespond(wctp_bool_t);

    ////////////////////////////
    // maxMessageLength attribute
    const char * 
    GetMaxMessageLength(void) const;
    void  
    SetMaxMessageLength(const char *);

    ////////////////////////////
    // mcrSupported attribute
    wctp_bool_t 
    GetMcrSupported(void) const;
    void  
    SetMcrSupported(wctp_bool_t);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlLookupData &);

    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    wctp_bool_t m_canRespond;
    XString     m_maxMessageLength;
    wctp_bool_t m_mcrSupported;

};
#endif
