/* File:  wctpXmlLookupMessageControl.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_LOOKUP_MESSAGE_CONTROL_HPP
#define WCTP_XML_LOOKUP_MESSAGE_CONTROL_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlLookupMessageControl : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlLookupMessageControl(); 
    wctpXmlLookupMessageControl(const wctpXmlLookupMessageControl &); 
    ~wctpXmlLookupMessageControl(); 
    wctpXmlLookupMessageControl& operator=(const wctpXmlLookupMessageControl &);

    ////////////////////////////
    // Assemble XML protocol text
    virtual XString 
    AssembleOperation(XmlContext& ctx);

    ////////////////////////////
    // Parse XML protocol text
    virtual wctp_parse_t 
    ParseObject (XString& msg, XmlNode *pTree);
    
    ////////////////////////////
    // messageID attribute
    const char * 
    GetMessageID(void) const;
    void  
    SetMessageID(const char *);

    ////////////////////////////
    // sendResponsesToID attribute
    const char * 
    GetSendResponsesToID(void) const;
    void  
    SetSendResponsesToID(const char *);

    ////////////////////////////
    // transactionID attribute
    const char * 
    GetTransactionID(void) const;
    void  
    SetTransactionID(const char *);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlLookupMessageControl &);

    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    XString m_messageID;
    XString m_sendResponsesToID;
    XString m_transactionID;
    
};
#endif
