/* File:  wctpXmlOriginator.hpp

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.skytel.com/downloads/wctpxml/worldcom_mpl_1.1.txt.

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is the WCTP Toolkit

The Initial Developer of the Original Code is WorldCom, Inc.
Portions created by WorldCom, Inc. are Copyright  2001
WorldCom, Inc.  All Rights Reserved.

Contributor(s):
  WorldCom, Inc. <skytel-strategic-apps@wcom.com>  

*/

#ifndef WCTP_XML_ORIGINATOR_HPP
#define WCTP_XML_ORIGINATOR_HPP

#include "wctpXmlOperation.hpp"

class wctpXmlOriginator : public wctpXmlOperation
{
public:
    ////////////////////////////
    // constructors, destructors, and assignemnt operators
    wctpXmlOriginator(); 
    wctpXmlOriginator(const wctpXmlOriginator &); 
    ~wctpXmlOriginator(); 
    wctpXmlOriginator& operator=(const wctpXmlOriginator &);

    ////////////////////////////
    // Assemble XML protocol text
    virtual XString 
    AssembleOperation(XmlContext& ctx);

    ////////////////////////////
    // Parse XML protocol text
    virtual wctp_parse_t 
    ParseObject(XString& msg, XmlNode *pTree);
    
    ////////////////////////////
    // miscInfo attribute
    const char * 
    GetMiscInfo(void) const;
    void  
    SetMiscInfo(const char *);

    ////////////////////////////
    // securityCode attribute
    const char * 
    GetSecurityCode(void) const;
    void  
    SetSecurityCode(const char *);

    ////////////////////////////
    // senderID attribute
    const char * 
    GetSenderID(void) const;
    void  
    SetSenderID(const char *);

private:
    virtual void 
    Init(void);

    virtual void 
    Copy(const wctpXmlOriginator &);

    wctp_parse_t 
    ParseAttribute(XString& msg, const XString& key, const XString& val);

    // attributes
    XString m_miscInfo;
    XString m_securityCode;
    XString m_senderID;
    
};
#endif
